<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DB\StorageProcedure\Param;

class LojaParametrizacaoTefController extends CrudWithParameterBag {

    protected $dataSourceName = 'ger12300_cadloja_parametrizacao_tef';
    protected $parameterBagColumns = array('CDFILIAL', 'CDLOJA', 'NRORG');
    protected $dataSourceManager;
    
    public function __construct(Manager $dataSourceManager, ParameterBag $parameterBag) {
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}
