<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Doctrine\DBAL\Connection;

class ConfigTerminalCaixaService {

    /**
     * @var 
     */

    protected $conn;
    
    private $PAGINAINICIAL  = "1";
    private $PAGINAFINAL    = "10";
    private $BOTAOINICIAL   = "01";
    private $BOTAOFINAL     = "48";
    
    public function __construct(Connection $conn) {
        $this->conn = $conn;
    }


    /**
     * @return int
     */
    
    public function autoCada($NRORG, $NRBUTTON, $NRCONFTELA, $CDFILIAL, $NRPGCONFTELA, $NMMESA, $CDIDENBUTTON, $NRMESA, $DTINIVIGENCIA) {
        
        $PAGINAINICIAL  = "1";
        $BOTAOINICIAL = "01";
        $QUANTIDADEMESAS = count($NRMESA);
        $MESASSALVAS = 0;
        
        $mensagemReturn = "";
        
        $params = array(
            ":NRORG"        => $NRORG,
            ":CDFILIAL"     => $CDFILIAL,
            ":NRCONFTELA"   => $NRCONFTELA,
            ":NRPGCONFTAUX" => $NRPGCONFTELA,
            ":NRBUTTONAUX"  => $NRBUTTON,
            ":NRPGCONFTELA" => $PAGINAINICIAL,
            ":NRBUTTON"      => $BOTAOINICIAL,
            ":DTINIVIGENCIA"      => $DTINIVIGENCIA
     	);
     	
     	if ($QUANTIDADEMESAS < (intval($this->PAGINAFINAL) * intval($this->BOTAOFINAL))) {
     	
            for($i=0;$i<count($NRMESA);$i++){
                
                $resultado = $this->getProximoBotaoEPagina($params);
      
                $BOTAO = $resultado["NRBUTTON"];
                $PAGINA = $resultado["NRPGCONFTELA"];
                
                $params[":NRPGCONFTELA"] = $PAGINA;
                $params[":NRBUTTON"]     = $BOTAO;
                
                
             	$execute = array(
             	    ":CDFILIAL"     => $CDFILIAL,
             	    ":NRCONFTELA"   => $NRCONFTELA,
             	    ":NRBUTTON"     => $BOTAO,
             	    ":NRPGCONFTELA"  => $PAGINA,
             	    ":NRBUTTONAUX"  => $NRBUTTON,
             	    ":NRPGCONFTAUX" => $NRPGCONFTELA,
             	    ":DSBUTTON"     => $NMMESA[$i],
             	    ":NRCOLORTEXT"  => 0,
             	    ":NRCOLORBACK"  => 65408,
             	    ":NRFONTETEXT"  => 8,
             	    ":DTINIVIGENCIA"  => $DTINIVIGENCIA,
             	    ":NRORG"  => $NRORG,
             	    ":CDIDENTBUTON" => $NRMESA[$i]
             	);
                $queryMax = $this->conn->executeQuery(self::INSERT_AUTOCAD_MESA, $execute);
                $MESASSALVAS++;
            }
            
            if($MESASSALVAS == $QUANTIDADEMESAS)
                $mensagemReturn = "Cadastro automático realizado com sucesso.";
            else
                $mensagemReturn = "Não foi possível cadastrar todas as mesas.";
            
        } else {
            $mensagemReturn = "Só podem ser incluídas mesas até a página 10 para cada ambiente.";
        }
        
        return $mensagemReturn;
    }
    
    public function getProximoBotaoEPagina ($parametros) {
        
        $retorno = array(
         	    "NRBUTTON"       => $this->BOTAOINICIAL,
         	    "NRPGCONFTELA"   => $this->PAGINAINICIAL
        );
        
        if($parametros[':NRBUTTON'] == ($this->BOTAOFINAL + 1)) {
            $parametros[':NRBUTTON']     = $this->BOTAOINICIAL;
            $parametros[':NRPGCONFTELA'] = $parametros[':NRPGCONFTELA'] + 1;
        } else if ($parametros[':NRPGCONFTELA'] > 10)
            throw new \Exception("Só podem ser incluídas mesas até a página 10 para cada ambiente.");
        
        $resultado = $this->conn->fetchAll(self::VERIFICAR_PAGINA_E_BOTAO_DISPONIVEIS, $parametros);
        
        if (empty($resultado)) {
            $retorno['NRBUTTON']     = str_pad($parametros[':NRBUTTON'], 2, "0", STR_PAD_LEFT);
            $retorno['NRPGCONFTELA'] = (string) $parametros[':NRPGCONFTELA'];
        } else {
            $parametros[':NRBUTTON'] = str_pad(($parametros[':NRBUTTON'] + 1), 2, "0", STR_PAD_LEFT);
            $retorno = $this->getProximoBotaoEPagina($parametros);
        }
        
        return $retorno;
    }
    
    public function deleteCascadeTable ($row) {
        
        $CDFILIAL = $row['CDFILIAL'];
        $NRCONFTELA  = $row['NRCONFTELA'];
        $NRPGCONFTELA = $row['NRPGCONFTELA'];
        $NRBUTTON = $row['NRBUTTON'];
        $NRORG = $row['NRORG'];
        
     	$execute = array(
     	    ":CDFILIAL"     => $CDFILIAL,
     	    ":NRCONFTELA"   => $NRCONFTELA,
     	    ":NRBUTTONAUX"  => $NRBUTTON,
     	    ":NRPGCONFTAUX" => $NRPGCONFTELA,
     	    ":NRORG"  => $NRORG
     	);
        $this->conn->executeQuery(self::DELETE_CASCADE_MESA, $execute);
    }
    
    const VERIFICAR_PAGINA_E_BOTAO_DISPONIVEIS = "
        SELECT CDFILIAL,
          NRCONFTELA
        FROM ITMENUCONFTE
        WHERE NRCONFTELA = :NRCONFTELA
        AND IDTPBUTTON   = '3'
        AND NRBUTTON     = :NRBUTTON
        AND NRPGCONFTELA = :NRPGCONFTELA
        AND NRORG        = :NRORG  
        AND IDTPBUTONAUX = '4'
        AND NRBUTTONAUX = :NRBUTTONAUX
        AND NRPGCONFTAUX = :NRPGCONFTAUX
        AND DTINIVIGENCIA = :DTINIVIGENCIA
        AND CDFILIAL = :CDFILIAL
    ";
  
    const INSERT_AUTOCAD_MESA = "
        INSERT INTO ITMENUCONFTE (CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
                                  NRPGCONFTAUX, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, NRFONTETEXT, CDIDENTBUTON, DTINIVIGENCIA, NRORG)
        VALUES (:CDFILIAL, :NRCONFTELA, '3', :NRBUTTON, :NRPGCONFTELA, '4', :NRBUTTONAUX,
                :NRPGCONFTAUX, :DSBUTTON, :NRCOLORTEXT, :NRCOLORBACK, :NRFONTETEXT, :CDIDENTBUTON, :DTINIVIGENCIA, :NRORG)
    ";
    
    const DELETE_CASCADE_MESA = "
        DELETE ITMENUCONFTE WHERE CDFILIAL = :CDFILIAL AND NRCONFTELA = :NRCONFTELA AND NRBUTTONAUX = :NRBUTTONAUX AND NRPGCONFTAUX = :NRPGCONFTAUX AND IDTPBUTTON = '3' AND IDTPBUTONAUX = '4'
    ";
    
} 
