<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendDiaSemanaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function findConsolidado($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO, $params);
    }
    
    public function findAnalitico($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO, $params);
    }

    const GET_VENDA_DIA_CONSOLIDADO = "
      SELECT 'TODAS' AS LABELFILIAL, PP.CDNVPRODUTO,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA,
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            FILOCAVE.NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/FILOCAVE.NRPESMESAVENDA),2) AS TICKETMEDIOPES,
            P4.CDARVPROD AS CDARVPRODP4, P4.CDPRODUTO AS CDPRODUTOP4, P4.NMPRODUTO AS NMPRODUTOP4, P4.CDARVPROD||' - '||P4.NMPRODUTO AS NMARVPRODP4,
            P1.CDARVPROD AS CDARVPRODP1, P1.CDPRODUTO AS CDPRODUTOP1, P1.NMPRODUTO AS NMPRODUTOP1, P1.CDARVPROD||' - '||P1.NMPRODUTO AS NMARVPRODP1,
            P2.CDARVPROD AS CDARVPRODP2, P2.CDPRODUTO AS CDPRODUTOP2, P2.NMPRODUTO AS NMPRODUTOP2, P2.CDARVPROD||' - '||P2.NMPRODUTO AS NMARVPRODP2,
            P3.CDARVPROD AS CDARVPRODP3, P3.CDPRODUTO AS CDPRODUTOP3, P3.NMPRODUTO AS NMPRODUTOP3, P3.CDARVPROD||' - '||P3.NMPRODUTO AS NMARVPRODP3,
            PP.CDARVPROD AS CDARVPRODP5, PP.CDPRODUTO AS CDPRODUTOP5, PP.NMPRODUTO AS NMPRODUTOP5, PP.CDARVPROD||' - '||PP.NMPRODUTO AS NMARVPRODP5
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA,1)) OVER (PARTITION BY FILOCA.NRORG, TO_CHAR(V.DTENTRVENDA,'D')) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN ( 
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                            FROM CAIXA C
                            JOIN ( 
                                SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                                    FROM LOJA L
                                        JOIN (
                                            SELECT F.CDFILIAL, F.NRORG
                                                FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                    AND F.NRORG = :NRORG 
                                        ) FI
                                            ON L.CDFILIAL = FI.CDFILIAL
                                                AND L.NRORG = FI.NRORG 
                                    WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                            ) FILO
                                ON C.CDFILIAL = FILO.CDFILIAL
                                    AND C.CDLOJA = FILO.CDLOJA
                                    AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.DIASEMANA, 'TODAS', FILOCAVE.NRPESMESAVENDA, PP.CDNVPRODUTO, :DTVENDAINI, 
            CASE WHEN FILOCAVE.DIASEMANA = 1 THEN 'Domingo' WHEN FILOCAVE.DIASEMANA = 2 THEN 'Segunda' WHEN FILOCAVE.DIASEMANA = 3 THEN 'Terça' WHEN FILOCAVE.DIASEMANA = 4 THEN 'Quarta' WHEN FILOCAVE.DIASEMANA = 5 THEN 'Quinta' WHEN FILOCAVE.DIASEMANA = 6 THEN 'Sexta' WHEN FILOCAVE.DIASEMANA = 7 THEN 'Sábado' END, :DTVENDAFIN, P4.CDARVPROD, P4.CDPRODUTO, P4.NMPRODUTO, 
            P4.CDARVPROD||' - '||P4.NMPRODUTO, ' - ', P4.NMPRODUTO, P1.CDARVPROD, P1.CDPRODUTO, 
            P1.NMPRODUTO, P1.CDARVPROD||' - '||P1.NMPRODUTO, ' - ', P1.NMPRODUTO, P2.CDARVPROD, 
            P2.CDPRODUTO, P2.NMPRODUTO, P2.CDARVPROD||' - '||P2.NMPRODUTO, ' - ', P2.NMPRODUTO, 
            P3.CDARVPROD, P3.CDPRODUTO, P3.NMPRODUTO, P3.CDARVPROD||' - '||P3.NMPRODUTO, ' - ', 
            P3.NMPRODUTO, PP.CDARVPROD, PP.CDPRODUTO, PP.NMPRODUTO, PP.CDARVPROD||' - '||PP.NMPRODUTO, 
            ' - ', PP.NMPRODUTO
    ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";

    const GET_VENDA_DIA_ANALITICO = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, PP.CDNVPRODUTO,
                FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
                CASE
                    WHEN FILOCAVE.DIASEMANA = 1
                        THEN 'Domingo'
                    WHEN FILOCAVE.DIASEMANA = 2
                        THEN 'Segunda'
                    WHEN FILOCAVE.DIASEMANA = 3
                        THEN 'Terça'
                    WHEN FILOCAVE.DIASEMANA = 4
                        THEN 'Quarta'
                    WHEN FILOCAVE.DIASEMANA = 5
                        THEN 'Quinta'
                    WHEN FILOCAVE.DIASEMANA = 6
                        THEN 'Sexta'
                    WHEN FILOCAVE.DIASEMANA = 7
                        THEN 'Sábado'
                END AS DIASEMANA, 
                COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
                SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
                ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
                ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
                FILOCAVE.NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/FILOCAVE.NRPESMESAVENDA),2) AS TICKETMEDIOPES,
                P4.CDARVPROD AS CDARVPRODP4, P4.CDPRODUTO AS CDPRODUTOP4, P4.NMPRODUTO AS NMPRODUTOP4, P4.CDARVPROD||' - '||P4.NMPRODUTO AS NMARVPRODP4,
    		    P1.CDARVPROD AS CDARVPRODP1, P1.CDPRODUTO AS CDPRODUTOP1, P1.NMPRODUTO AS NMPRODUTOP1, P1.CDARVPROD||' - '||P1.NMPRODUTO AS NMARVPRODP1,
    		    P2.CDARVPROD AS CDARVPRODP2, P2.CDPRODUTO AS CDPRODUTOP2, P2.NMPRODUTO AS NMPRODUTOP2, P2.CDARVPROD||' - '||P2.NMPRODUTO AS NMARVPRODP2,
    		    P3.CDARVPROD AS CDARVPRODP3, P3.CDPRODUTO AS CDPRODUTOP3, P3.NMPRODUTO AS NMPRODUTOP3, P3.CDARVPROD||' - '||P3.NMPRODUTO AS NMARVPRODP3,
    		    PP.CDARVPROD AS CDARVPRODP5, PP.CDPRODUTO AS CDPRODUTOP5, PP.NMPRODUTO AS NMPRODUTOP5, PP.CDARVPROD||' - '||PP.NMPRODUTO AS NMARVPRODP5
		    FROM ITEMVENDA I
                JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
                JOIN (
                    SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                            FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA, 'D')) AS NRPESMESAVENDA
                        FROM VENDA V
                            JOIN (
                                SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                    FROM CAIXA C
                                        JOIN (
                                            SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                FROM LOJA L
                                                    JOIN (
                                                        SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                            FROM FILIAL F
                                                            WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                                AND F.NRORG = :NRORG 
                                                    ) FI
                                                        ON L.CDFILIAL = FI.CDFILIAL
                                                            AND L.NRORG = FI.NRORG 
                                                WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                        ) FILO
                                            ON C.CDFILIAL = FILO.CDFILIAL
                                                AND C.CDLOJA = FILO.CDLOJA
                                                AND C.NRORG = FILO.NRORG
                            ) FILOCA
                                ON V.CDCAIXA = FILOCA.CDCAIXA
                                    AND V.CDLOJA = FILOCA.CDLOJA
                                    AND V.CDFILIAL = FILOCA.CDFILIAL
                                    AND V.NRORG = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O'
                            AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                ) FILOCAVE
                    ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                        AND I.CDFILIAL = FILOCAVE.CDFILIAL
                        AND I.CDCAIXA = FILOCAVE.CDCAIXA
                        AND I.NRORG = FILOCAVE.NRORG
            GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
                FILOCAVE.NRPESMESAVENDA, PP.CDNVPRODUTO, :DTVENDAINI, :DTVENDAFIN, CASE WHEN FILOCAVE.DIASEMANA = 1 THEN 'Domingo' WHEN FILOCAVE.DIASEMANA = 2 THEN 'Segunda' WHEN FILOCAVE.DIASEMANA = 3 THEN 'Terça' WHEN FILOCAVE.DIASEMANA = 4 THEN 'Quarta' WHEN FILOCAVE.DIASEMANA = 5 THEN 'Quinta' WHEN FILOCAVE.DIASEMANA = 6 THEN 'Sexta' WHEN FILOCAVE.DIASEMANA = 7 THEN 'Sábado' END, 
                P4.CDARVPROD, P4.CDPRODUTO, P4.NMPRODUTO, P4.CDARVPROD||' - '||P4.NMPRODUTO, P1.CDARVPROD, 
                P1.CDPRODUTO, P1.NMPRODUTO, P1.CDARVPROD||' - '||P1.NMPRODUTO, P2.CDARVPROD, P2.CDPRODUTO, 
                P2.NMPRODUTO, P2.CDARVPROD||' - '||P2.NMPRODUTO, P3.CDARVPROD, P3.CDPRODUTO, P3.NMPRODUTO, 
                P3.CDARVPROD||' - '||P3.NMPRODUTO, PP.CDARVPROD, PP.CDPRODUTO, PP.NMPRODUTO, PP.CDARVPROD||' - '||PP.NMPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
}